#!/bin/bash
#
# Copyright (C) 2019 OX Software GmbH
# 
# This file is part of OX Automation.
#
# OX Automation is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OX Automation is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# 
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with OX Automation. If not, see <http://www.gnu.org/licenses/>.
#
#
# Authors:
# Benedikt Kroening <benedikt.kroening@open-xchange.com>
#
set -e
SCRIPT_DIR="$( cd "$(dirname "$0")" ; pwd -P)"

source ${SCRIPT_DIR}/../../lib/common.bash




INIT_STATE_FILE="/opt/open-xchange/etc/90-init-qa-done"

if [ ! -f ${INIT_STATE_FILE} ]; then

    if [ ${OX_ENV_QA} = true ]; then
        if [[ -z "${OX_MAIL_DOMAIN}" ]]; then
            echo "ERROR: OX_MAIL_DOMAIN Paramater is missing"
            exit 1
        fi
        waitPort localhost 8009
        echo "Creating default QA context & users ..."        
        ${SCRIPT_DIR}/../create-context.sh -d ${OX_MAIL_DOMAIN} -l "${OX_MAIL_DOMAIN},defaultcontext" -s "${OX_MAIL_HOST}"
    else
        echo "Not creating any users"
        sleep 5
    fi

    echo "$(date)" > ${INIT_STATE_FILE}

else
    echo "QA init already executed! Skipping"
    exit 0
fi
